from __future__ import annotations

class SolveDetails:
    @property
    def time(self) -> float: ...
    @property
    def status_code(self) -> int: ...
    @property
    def status(self) -> str: ...
    @property
    def problem_type(self) -> str: ...
    @property
    def columns(self) -> int: ...
    @property
    def nb_linear_nonzeros(self) -> int: ...
    @property
    def mip_relative_gap(self) -> float: ...

    gap = mip_relative_gap

    @property
    def best_bound(self) -> float: ...
    @property
    def nb_iterations(self) -> int | tuple[int, ...]: ...
    @property
    def nb_nodes_processed(self) -> int | tuple[int, ...]: ...
    def print_information(self) -> None: ...
    def to_string(self) -> str: ...
    def has_hit_limit(self) -> bool: ...
