from __future__ import annotations

from docplex.mp.constr import BinaryConstraint, NotEqualConstraint

class Operand:
    def negate(self) -> Operand: ...
    def __le__(self, other: Operand | float) -> BinaryConstraint: ...
    def __ge__(self, other: Operand | float) -> BinaryConstraint: ...
    def __eq__(self, other: Operand | float) -> BinaryConstraint: ...  # type: ignore

class LinearOperand(Operand):
    def __ne__(self, other: Operand | float) -> NotEqualConstraint: ...  # type: ignore
